/*
 * This file is part of openSDK.
 *
 * Copyright (C) 2006-2007 openSDK team
 *
 * openSDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * openSDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with openSDK; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *     $Id: helper.h,v 1.5 2007/07/16 13:09:00 nuno-lopes Exp $
 */

#include <ModuleData.h>
#include <pthread.h>
#include <signal.h>
#include <string>

#define BLOCK_SIGNALS() { sigset_t set; sigfillset(&set); pthread_sigmask(SIG_SETMASK, &set, NULL); }
#define BLOCK_SIGNAL(s) { sigset_t set; sigemptyset(&set); sigaddset(&set, (s)); pthread_sigmask(SIG_SETMASK, &set, NULL); }
#define BLOCK_SIGNALS_EXCEPT(s) { sigset_t set; sigfillset(&set); sigdelset(&set, (s)); pthread_sigmask(SIG_SETMASK, &set, NULL); }

void* module_executor(void *ptr);

struct executorArg {
	executorArg(std::string name, perThreadStruct* data) : mod_name(name), threadData(data) {}

	std::string mod_name;
	perThreadStruct* threadData;
};
