/*
 * This file is part of openSDK.
 *
 * Copyright (C) 2006-2007 openSDK team
 *
 * openSDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * openSDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with openSDK; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *     $Id: opensdkAPI.h,v 1.6 2007/07/16 15:21:43 nuno-lopes Exp $
 */

#ifndef __opensdkAPI_h__
#define __opensdkAPI_h__

#include <map>
#include <vector>
#include <string>
#include <pthread.h>
#include <OPENR/OPENR.h>
#include <OPENR/ODataFormats.h>
#include <SystemTime.h>
#include <OPENR/OTime.h>

extern pthread_key_t perThreadKey;
extern bool __in_shutdown;
extern bool __DoInitCompleted;
extern bool __DoStopCompleted;


OStatus RegisterServiceEntry(const OServiceEntry& entry, const char *name);
OStatus _sendMessage(OServiceEntry entry, void *msg);
OStatus GetJointValue(OPrimitiveID id, OJointValue* value);
OStatus GetSensorValue(OPrimitiveID id, OSensorValue* value);
char* resolve_case_insensitive_path(const char *path);
sbyte GetTimeDifference(void);
OStatus SetTimeDifference(sbyte timeDifference);
OStatus SetTime(const OTime& time);
SystemTime getSystemTime(void);

#endif
