// the above code was copied from an example of the OpenAL manual
// but doesn't seem to work :(

#include <AL/al.h>
#include <AL/alut.h>
#include <AL/alc.h>

#include <iostream>
#include <Platform.h>

using namespace std;
#define CHECK_SYSCALL(val, msg) if ((val) == -1) { perror(msg); return 3; }
#define NUM_BUFFERS 1

int main(int argc, char *argv[])
{

#define DisplayALError(s, e) cout << s << (int)e << endl;
	// INIT
	ALenum error;
	ALCdevice *Device = alcOpenDevice(NULL); // select the "preferred device"
	if (Device) {
		alcMakeContextCurrent(alcCreateContext(Device,NULL));
	}
	// Check for EAX 2.0 support
	//alIsExtensionPresent((const ALubyte*)"EAX2.0");
	// Generate Buffers
	alGetError(); // clear error code
	ALuint g_Buffers[NUM_BUFFERS];
	alGenBuffers(NUM_BUFFERS, g_Buffers);
	if ((error = alGetError()) != AL_NO_ERROR) {
		DisplayALError("alGenBuffers :", error);
		return 2;
	}
	// Load test.wav
	ALenum format;
	ALvoid *data;
	ALsizei size, freq;
	ALboolean loop;
	alutLoadWAVFile((ALbyte*)"test.wav",&format,&data,&size,&freq,&loop);
	if ((error = alGetError()) != AL_NO_ERROR) {
		DisplayALError("alutLoadWAVFile test.wav : ", error);
		alDeleteBuffers(NUM_BUFFERS, g_Buffers);
		return 3;
	}
	// Copy test.wav data into AL Buffer 0
	alBufferData(g_Buffers[0],format,data,size,freq);
	if ((error = alGetError()) != AL_NO_ERROR) {
		DisplayALError("alBufferData buffer 0 : ", error);
		alDeleteBuffers(NUM_BUFFERS, g_Buffers);
		return 4;
	}
	// Unload test.wav
	alutUnloadWAV(format,data,size,freq);
	if ((error = alGetError()) != AL_NO_ERROR) {
		DisplayALError("alutUnloadWAV : ", error);
		alDeleteBuffers(NUM_BUFFERS, g_Buffers);
		return 5;
	}
	// Generate Sources
	ALuint source[1];
	alGenSources(1,source);
	if ((error = alGetError()) != AL_NO_ERROR) {
		DisplayALError("alGenSources 1 : ", error);
		return 6;
	}

	// Attach buffer 0 to source
/*	ALfloat source0Pos[]={-2,0,0}, source0Vel[]={0,0,0};

	alSourcef(source[0], AL_PITCH, 1.0f);
	alSourcef(source[0], AL_GAIN, 1.0f);
	alSourcefv(source[0], AL_POSITION, source0Pos);
	alSourcefv(source[0], AL_VELOCITY, source0Vel);*/
	alSourcei(source[0], AL_BUFFER, g_Buffers[0]);
	//alSourcei(source[0], AL_LOOPING, AL_TRUE);
	if ((error = alGetError()) != AL_NO_ERROR) {
		DisplayALError("alSourcei AL_BUFFER 0 : ", error);
	}

	// EXIT
	ALCcontext *Context=alcGetCurrentContext();
	Device=alcGetContextsDevice(Context);
	alcMakeContextCurrent(NULL);
	alcDestroyContext(Context);
	alcCloseDevice(Device);

	return 0;
}
