/*
 * This file is part of openSDK.
 *
 * Copyright (C) 2006-2007 openSDK team
 *
 * openSDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * openSDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with openSDK; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *     $Id: DataManager.cc,v 1.3 2007/04/27 10:28:42 nuno-lopes Exp $
 */

#include <OPENR/DataManager.h>

DataManager::DataManager()
{
	// do nothing
}


DataManager::~DataManager()
{
	ClearAll();
}


void DataManager::Register(const SubjectID& subject, RCRegion *myRCR, RCRegion *srcRCR)
{
	dataInfo_.push_back(DataInfo(subject, myRCR, srcRCR));
}


 void DataManager::InitUnregistration()
{
	// do nothing
}


DataInfo DataManager::Unregister(const SubjectID& subject)
{
	DataInfo info;

	for (list<DataInfo>::iterator it = dataInfo_.begin(); it != dataInfo_.end(); ) {
		if ((*it).subject == subject) {
			info = (*it);
			(*it).myRCRegion->RemoveReference();
			it = dataInfo_.erase(it);
		} else {
			++it;
		}
	}

	return info;
}


void DataManager::Clear(const SubjectID& subject)
{
	for (list<DataInfo>::iterator it = dataInfo_.begin(); it != dataInfo_.end(); ) {
		if ((*it).subject == subject) {
			it = dataInfo_.erase(it);
		} else {
			++it;
		}
	}
}


void DataManager::ClearAll()
{
	dataInfo_.clear();
}


SubjectID DataManager::FindSender(RCRegion *ptr) const
{
	for (list<DataInfo>::const_iterator it = dataInfo_.begin(); it != dataInfo_.end(); ++it) {
		if ((*it).srcRCRegion == ptr) {
			return (*it).subject;
		}
	}

	return SubjectID();
}
