/*
 * This file is part of openSDK.
 *
 * Copyright (C) 2006-2007 openSDK team
 *
 * openSDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * openSDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with openSDK; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *     $Id: IPAddress.cc,v 1.3 2007/01/26 23:12:05 nuno-lopes Exp $
 */

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
// avoid warnings
#undef IPPROTO_IP
#undef IPPROTO_ICMP
#undef IPPROTO_IGMP
#undef IPPROTO_GGP
#undef IPPROTO_TCP
#undef IPPROTO_EGP
#undef IPPROTO_PUP
#undef IPPROTO_UDP
#undef IPPROTO_IDP
#undef IPPROTO_TP
#undef IPPROTO_EON
#undef IPPROTO_ENCAP
#undef IPPROTO_RAW
#undef IPPROTO_MAX
#undef IPPROTO_RESERVED
#undef IPPROTO_UNRESERVED
#include <IPAddress.h>

IPAddress::IPAddress(byte b1, byte b2, byte b3, byte b4)
{
	address = (b1 << 24) + (b2 << 16) + (b3 << 8) + b4;
}

IPAddress::IPAddress(const char *str)
{
	struct in_addr in;
	inet_aton(str, &in);
	address = in.s_addr;
}

char* IPAddress::GetAsString(char* str) const
{
	struct in_addr in = {address};
	strcpy(str, inet_ntoa(in));
	return str;
}

OSTREAM& IPAddress::print(OSTREAM& os) const
{
	char tmp[50];
	os << GetAsString(tmp);
	return os;
}

const IPAddress IP_ADDR_ANY((uint32)INADDR_ANY);
const IPAddress IP_ADDR_BROADCAST((uint32)INADDR_BROADCAST);
