/*
 * This file is part of openSDK.
 *
 * Copyright (C) 2006-2007 openSDK team
 *
 * openSDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * openSDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with openSDK; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *     $Id: OPENREvent.cc,v 1.5 2007/01/26 23:12:05 nuno-lopes Exp $
 */

#include <OPENR/OPENREvent.h>

OSystemEvent::OSystemEvent(OReason reason, void* param, size_t paramSize)
{
	reason_    = reason;
	param_     = param;
	paramSize_ = paramSize;
}

OSystemEvent::~OSystemEvent()
{
	// nothing to do
}

OReason OSystemEvent::Reason() const
{
	return reason_;
}

const void* OSystemEvent::Param() const
{
	return param_;
}

size_t OSystemEvent::ParamSize() const
{
	return paramSize_;
}
