/*
 * This file is part of openSDK.
 *
 * Copyright (C) 2006-2007 openSDK team
 *
 * openSDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * openSDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with openSDK; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *     $Id: OPower.cc,v 1.3 2007/01/26 23:12:05 nuno-lopes Exp $
 */

#include <OPENR/OPower.h>
#include <time.h>

OPowerStatus::OPowerStatus() {
	// do nothing
}

OPowerStatus::OPowerStatus(longword rs, word bs, word rc, word tmpr, word fc, word vlt, word crnt, sbyte td, byte vlm)
{
	robotStatus          = rs;
	batteryStatus        = bs;
	remainingCapacity    = rc;
	temperature          = tmpr;
	fullyChargedCapacity = fc;
	voltage              = vlt;
	current              = crnt;
	timeDif              = td;
	volume               = vlm;
}

OPowerStatus::OPowerStatus(const OPowerStatus& ps)
{
	*this = ps;
}

void OPowerStatus::Set(longword rs, word bs, word rc, word tmpr, sbyte td, byte vlm)
{
	robotStatus          = rs;
	batteryStatus        = bs;
	remainingCapacity    = rc;
	temperature          = tmpr;
	timeDif              = td;
	volume               = vlm;
}

OPowerStatus& OPowerStatus::operator=(const OPowerStatus& ps)
{
	robotStatus          = ps.robotStatus;
	batteryStatus        = ps.batteryStatus;
	remainingCapacity    = ps.remainingCapacity;
	temperature          = ps.temperature;
	fullyChargedCapacity = ps.fullyChargedCapacity;
	voltage              = ps.voltage;
	current              = ps.current;
	timeDif              = ps.timeDif;
	volume               = ps.volume;

	return *this;
}

void OPowerStatus::Print() const
{
	//TODO
}

void OPowerStatus::PrintDetail() const
{
	//TODO
}


// OBootCondition class
OBootCondition::OBootCondition()
{
	// do nothing
}

OBootCondition::OBootCondition(word bm)
{
	bitmap = bm;
}

OBootCondition::OBootCondition(word bm, time_t bt, longword btt)
{
	bitmap = bm;
	bootTime = bt;
	bootTimeType = btt;
}

OBootCondition::OBootCondition(word bm, time_t bt, longword btt, byte vl)
{
	bitmap = bm;
	bootTime = bt;
	bootTimeType = btt;
	vibrationLevel = vl;
}

OBootCondition::OBootCondition(const OBootCondition& bc)
{
	*this = bc;
}

OBootCondition& OBootCondition::operator=(const OBootCondition& bc)
{
	bitmap = bc.bitmap;
	bootTime = bc.bootTime;
	bootTimeType = bc.bootTimeType;
	vibrationLevel = bc.vibrationLevel;

	return *this;
}
