/*
 * This file is part of openSDK.
 *
 * Copyright (C) 2006-2007 openSDK team
 *
 * openSDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * openSDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with openSDK; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *     $Id: OSyslog.cc,v 1.6 2007/01/26 23:12:05 nuno-lopes Exp $
 */

#include <OPENR/OSyslog.h>
#include <stdio.h>
#include <stdarg.h>
#include <pthread.h>
#include "ModuleData.h"

static pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
#define LOCK() pthread_mutex_lock(&mutex)
#define UNLOCK() pthread_mutex_unlock(&mutex)


OStatus osyslog(OSyslogPriority priority, const char* format, ...)
{
	va_list args;
	va_start(args, format);

	LOCK();
	printf("[oid:%zd,prio:%ld] ", MOD_DATA(OID), (unsigned long)priority);
	vprintf(format, args);
	printf("\n");
	UNLOCK();

	va_end(args);
	return oSUCCESS;
}

OStatus osysprint(const char* format, ...)
{
	va_list args;
	va_start(args, format);

	LOCK();
	vprintf(format, args);
	UNLOCK();

	va_end(args);
	return oSUCCESS;
}
