/*
 * This file is part of openSDK.
 *
 * Copyright (C) 2006-2007 openSDK team
 *
 * openSDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * openSDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with openSDK; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *     $Id: OpenSdkEndpointInfo.h,v 1.10 2007/04/22 14:34:17 nuno-lopes Exp $
 */

#ifndef __OpenSdkEndpointInfo_h__
#define __OpenSdkEndpointInfo_h__

#include <OPENR/OPENR.h>
#include <ant.h>
#include <IPAddress.h>
#include <DNSEndpointMsg.h>
#include <pthread.h>

#define NO_SOCKET -1


class OpenSdkEndpointInfo
{

public:

	OpenSdkEndpointInfo();
	OpenSdkEndpointInfo(OpenSdkEndpointInfo&);
	~OpenSdkEndpointInfo();

	enum State {
		NEW,
		LISTENING,
		CONNECTING,
		BINDING,
		ACTIVE,
		CLOSED
	} state;

	antEnvMsg *msg;
	OServiceEntry entry;

	int server_socket;
	int socket;

	void *buffer;
	size_t size;

	// connect stuff
	short port;
	IPAddress ip;

	// listen
	pthread_mutex_t *listen_mutex;

	// dns name resolving
	char *hostname;

};

#endif
