/*
 * This file is part of openSDK.
 *
 * Copyright (C) 2006-2007 openSDK team
 *
 * openSDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * openSDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with openSDK; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *     $Id: OpenSdkThread.h,v 1.4 2007/01/26 23:12:05 nuno-lopes Exp $
 */

#ifndef __OpenSdkThreads_h__
#define __OpenSdkThreads_h__

#include <pthread.h>
#include <vector>

#define THREAD_POOL_SIZE 16

enum ThreadState { Idle, Running, Dead};

typedef void*(*FuncPointer)(void*);

class OpenSdkThread
{
 public:
    static int runFunction(void * (func)(void*), void * arg);
    static void initThreadPool(void); // this has to be called when OpenSdk starts
    static void cleanThreadPool(void);

    OpenSdkThread();
    ~OpenSdkThread();

    void deleteThread(void);

    pthread_mutex_t runMutex;
    pthread_mutex_t stateMutex;
    ThreadState state;
    FuncPointer func;
    void * arg;

 private:
    static std::vector<OpenSdkThread*>* threadVector;

};

#endif
