/*
 * This file is part of openSDK.
 *
 * Copyright (C) 2006-2007 openSDK team
 *
 * openSDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * openSDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with openSDK; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *     $Id: antTypes.cc,v 1.3 2007/01/26 23:12:05 nuno-lopes Exp $
 */

#include <antTypes.h>

static const char* antErrorStrings[] = {
	"ANT_SUCCESS",
	"ANT_FAIL",
	"ANT_NOMEMORY",
	"ANT_INVALIDPTR",
	"ANT_NO_STATE_TRANSITION",
	"ANT_SDU_BADRANGE",
	"ANT_SDU_NOMORE_DATACELL",
	"ANT_SDU_NOOWNER",
	"ANT_SDUPOOL_ALLOCATED",
	"ANT_SDUPOOL_NOTASSIGNED",
	"ANT_QUEUE_EMPTY",
	"ANT_QUEUE_STATE",
	"ANT_QUEUE_CLOSED",
	"ANT_QUEUE_REJECTED",
	"ANT_QUEUE_BLOCKED",
	"ANT_INVALIDMODULEID",
	"ANT_TMR_TYPE_INVALID",
	"ANT_TMR_MAXNMBR_REACHED",
	"ANT_NOMESSAGES",
	"ANT_NAMING_ENTRY_EXISTS",
	"ANT_NAMING_NO_SUCH_NAME",
	"ANT_NAMING_NAME_INVALID",
	"ANT_REGISTRY_DUPLICATE_KEY",
	"ANT_REGISTRY_NO_KEY",
	"ANT_REGISTRY_WRONG_TYPE",
	"ANT_REGISTRY_INVALID_KEY",
	"ANT_REGISTRY_INVALID_VALUE",
	"ANT_ENDPOINT_NOFACTORY",
	"ANT_NOT_INITIALIZED",
	"ANT_INITIALIZING"
};

const char* antErrorString(antError error)
{
	if ((unsigned)error >= sizeof(antErrorStrings)/sizeof(*antErrorStrings) || error < 0) {
		return "UNKNOWN ANT ERROR";
	}
	return antErrorStrings[error];
}

OSTREAM& operator<<(OSTREAM& os, antError error)
{
	os << antErrorString(error);
	return os;
}
